
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Find and Replace Patterns within Vortex Modules ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ...An Extension to OpenMDT2VT
;; ...Stand alone version based on version 1.5...
;;
;; By Karl McNeil
;; March 31st 2012

Global $PatString, $CurrentPAT,$Repeat, $clone , $count, $IN, $newline,$TOTAL_Pats, $Tmp, $Tmp2
$newline = chr(13)&chr(10)
Hotkeyset("{ESC}","killall")


Main()
Exit

Func Main()
;; Load Vortex Module... Pressing CANCEL will skip this,
;; and program will default to reading from the clipboard instead...

$Tmp2 = FileOpenDialog( "Loading Vortex Tracker Module", @ScriptDir, " (*.txt)", 2)
; option 2 = dialog remains until valid path/file selected

If @error OR $Tmp2="" Then
    Beep(500,200)
    Else
        $count = FileOpen($Tmp2, 0)
        ; Check if file opened for reading OK
        If $count = -1 Then
           MsgBox(0, "Error", "Unable to open file.")
           Exit
           EndIf
        $Tmp = FileRead($count)
        FileClose($count)
        Send("^")
        ClipPut($Tmp)
EndIf

$IN=ClipGet() ; The whole TextModule
;; Need to calculate the total number of pattern places are on the OrdList

$clone = StringInStr ( $IN, "PlayOrder"); Marks start of line
$Repeat = StringInStr ( $IN, $newline, 2, 1, $clone) ; Marks end of line
$Repeat = $Repeat - $clone ; now Marks the length between

$count=0
DO
$count=$count+1
UNTIL StringInStr ( $IN, ",", 2, $count, $clone, $Repeat )=0
$TOTAL_Pats = $count

; Create $PatString
$PatString=""
$count=-1

DO
$count=$count+1
$PatString=$PatString & Chr($count)
UNTIL $count=$TOTAL_Pats ; $patString now contains a list of chrs from 0 to TOTAL_Patterns

$CurrentPAT = -1
DO
$CurrentPAT = $CurrentPAT +1
$Pattern=StringInStr($IN,"[Pattern"& $CurrentPAT &"]",0,1) ; find Header
$Pattern=2+StringInStr($IN, $newline,0,1,$Pattern); find start of data past header
$Pattern=StringMid($IN,$Pattern,3264); $pattern now holds the whole pattern to compare minus the header

DO
$Repeat=StringInStr($IN,$pattern,0,2)
If $Repeat Then ; BackTrack to Header to identify clone pattern

	$clone=Number(StringMid($IN,1+StringInStr($IN,"n",1,1,$Repeat-8),(StringInStr($IN,"]",1,1,$Repeat-8)- StringInStr($IN,"n",1,1,$Repeat-8))))
	$PatString=StringReplace ( $PatString, chr($clone), chr($CurrentPAT)) ; All clones ref's replaced by originals in OrdList string
	$IN=StringReplace ( $IN, $newline&"[Pattern"&$clone&"]"& $newline & $Pattern, "", 0, 2); Destroy all traces of titled clone pattern from module
	EndIf

UNTIL $Repeat=0
UNTIL $CurrentPAT = $TOTAL_Pats

; Create the new OrdList:
$Pattern=""
$count=0
DO
$Pattern=$Pattern & ASC(StringMid($PatString,$count+1,1)) & ","
$count=$count+1
UNTIL $count=$TOTAL_Pats
$Pattern=StringTrimRight($Pattern,1) ; remove excess comma
$Pattern="PlayOrder=L" & $Pattern

; Find and replace old order list:
$clone = StringMid ( $IN, StringInStr($IN,"PlayOrder",0,1),(StringInStr($IN,$newline,0,1,StringInStr($IN,"PlayOrder",0,1))-StringInStr($IN,"PlayOrder",0,1)) )
$IN=StringReplace ( $IN, $clone, $Pattern, 1,2)   ; Replace Orderlist

;; Finally put it all back in clipboard
ClipPut($IN)
$Tmp=$IN
Send("^")
Beep(800,100)
;;;;;;;;;;;;;;;;;;; ;;;;;;;;;;;
;; FILE SAVING ;;;; ;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;; ;;;;;;;;;;;
$Tmp2 = FileSaveDialog( "Saving Vortex Tracker Module", @ScriptDir, " (*.txt)", 2)
; option 2 = dialog remains until valid path/file selected

If @error OR $Tmp2="" Then
    Beep(500,200)
Else
If StringInStr ( $Tmp2, ".txt",1) = 0 Then
$Tmp2=$Tmp2 & ".txt" ; Add extension if user doesn't add it...
EndIf
$count = FileOpen($Tmp2, 2)
; Check if file opened for writing OK
If $count = -1 Then
    MsgBox(0, "Error", "Unable to open file.")
    Exit
    EndIf
FileWrite($count, $Tmp)
FileClose($count)
Send("^")
EndIf
EndFunc

Func killall()
ClipPut($IN)
Send("^")
exit
EndFunc